/* Demonstraatioita C-kielestä: merkkijono
 *
 * Pakollinen palautustehtävä:
 *  
 * - täydennä toteutustiedostoon "merkkijono.c" alempana esitelty ja
 *   dokumentoitu aliohjelma, joka poistaa merkkijonosta kaikki
 *   tietyn, parametrina annettavan, merkin esiintymät. Eli jos
 *   jonosta "Aamukasteesta alkaa aurinko" poistaisi merkin 'a', siitä
 *   pitäisi tulla "Amuksteest lk urinko". Jos tuloksesta edelleen
 *   poistaisi merkin 'e', pitäisi jäädä enää "Amukstst lk
 *   urinko". Huomioi C-merkkijonon toiminta, mm. lopussa nollamerkki,
 *   joka vielä mahtuu varattuun muistialueeseen eli "puskuriin".
 *
 *   Lisävihje 1: Tämä on hyvä testi Ohjelmointi 1 -tietotaidolle.
 *                Jos tuntuu vaikealle, kannattaa kerrata pikapikaa :)
 *
 *   Lisävihje 2: Mikäli päädyt algoritmiin, jossa käytetään
 *                paikallista aputaulukkoa, muista että se sijaitsee
 *                suorituspinossa jonka koko sisältö luonnostaan
 *                häviää aliohjelman lopussa. Koska ns. dynaamista
 *                muistinvarausta ei ole opeteltu, ainoa tapa saada
 *                tulosjono pääohjelmalle on itse asiassa
 *                ylikirjoittaa aiempi sisältö. Se on mahdollista,
 *                koska otat parametrina muistiosoitteen. Tämän
 *                vihjeen tarkoitus ei ole sanoa että paikallisen
 *                aputaulukon käyttö olisi mitenkään tarpeellista tai
 *                järkevää...
 *
 *   Lisävihje 3: Tämän pitäisi olla helppo asia tehdä, mutta
 *                käytännössä ei näytä kaikille olevan... jostain
 *                syystä...  Jos ei onnistu, mieti miksi ei, ja
 *                muotoile kysymykseksi!
 *
 *   Lisävihje 4: Etenkin alkuvaiheessa kannattanee piirrellä ensin
 *                jotain havainnollistuksia paperille, että ymmärtää
 *                ohjelman päämäärän, ennen kuin edes yrittää
 *                kirjoittaa sitä.
 *
 */


/** 
 * TEHTÄVÄ: toteuta itse. Poistaa jonosta annetun merkin
 * esiintymät. Palauttaa muokatun jonon pituuden (poiston takia siis
 * korkeintaan sama kuin alkuperäinen pituus). Palauttaa virheen
 * ilmaisemiseksi -1, jos yritettiin poistaa nollamerkki
 * '\0'. Palauttaa virheen ilmaisemiseksi -2, jos muokattavassa
 * puskurissa oli "maxkoko" kappaletta merkkejä, joista yksikään ei
 * ollut merkkijonon päättävä nollamerkki '\0'.
 */
int mjono_poista_merkki(char puskuri[], int maxkoko, char poistettava);

/** 
 * Korvaa merkkijonosta tietyn merkin esiintymät uudella ja palauttaa
 * korvattujen lukumäärän. Nolla ei ole sallittu korvattava merkki;
 * tämän yrittämisestä palautetaan virheen merkiksi -1. Jos merkkijono
 * ei lopu sopimuksen mukaan nollaan, palauttaa -2.
 *
 * Huomautus: Joissain aliohjelmissa ei muuteta osoitetun muistialueen
 * sisältöä, minkä hyvätapainen koodaaja ilmoittaa laittamalla
 * osoiteparametrin alkuun määreen 'const' eli vakio. Nyt taas
 * tarkoitus on nimenomaan muuttaa merkkijonon sisältöä ja siksi tässä
 * aliohjelmaesittelyssä ei tuota const'ia ole:
 */
int mjono_korvaa_merkki(char puskuri[], int maxkoko, 
                        char korvattava, char uusi);
