/* Demonstraatioita C-kielen tyypeistä, erityisesti tietuetyyppi eli
 * 'struktuuri'. Tässä hyvin yksinkertainen - on vain kolme nimettyä
 * kenttää, jotka ovat keskenään samantyyppisiä.
 *
 * (Lisähuomio: C99 -standardin mukaan tiedetään tasan tarkkaan,
 * mitä tässä esiintyvät liukuluvut koneen esityksessä ovat. Standardi
 * sanoo: "The double type matches the IEC 60559 double
 * format". Liukulukujen esitysmuodot eivät ole kurssin aihepiiriä,
 * mutta standardien merkitys on.)
 *
 */

/* Tässä määritellään tietuetyyppi, jolla voidaan esittää
 * kolmiulotteisen avaruuden vektori eli esimerkiksi sijainti tai
 * suunta leveys-, pituus- ja syvyyssuuntaan. Tietueiden rakenne
 * määritellään usein otsikkotiedostossa, jossa myös esitellään
 * julkiset aliohjelmat, joilla tietueen sisältöä on tarkoitus
 * käsitellä.  "Tiedon piilotusta" ei sinänsä ole: Myös
 * sovellusohjelma pääsee halutessaan käsiksi tietuekenttiin
 * kulkematta erikseen määritellyn aliohjelma-/metodirajapinnan
 * kautta.
 */
typedef struct {
    double x;
    double y;
    double z;
} vect3d_t;

/** TEHTÄVÄ: toteuta itse. Aliohjelma, joka laskee ja palauttaa kahden
 * vect3d_t -tyyppisen (osoittimina annetun) tietueen
 * pistetulon. Pistetulohan on matemaattisesti kaava x1*x2 + y1*y2 +
 * z1*z2 vektorien (x1,y1,z1) ja (x2,y2,z2) välillä.
 */
double vect3d_pistetulo(const vect3d_t *v1, const vect3d_t *v2);

/** 
 * Laskee vektorin euklidisen normin eli "mittanauhaetäisyyden"
 * origosta. Huomaa tähti-syntaksi osoitintyyppiselle
 * parametrille. const -määre lupaa, että tämä aliohjelma ei muuta
 * tietueen sisältöä.
 */
double vect3d_norm(const vect3d_t *v);
